
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Token Generator</title>
    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet">
    <style>
        .container {
            margin-top: 50px;
        }
        .token{
            font-size: 100px;
        }
    </style>
</head>
<body>

<div class="container">
    <h1 class="text-center">Token Generator (Setiap 15 Menit)</h1>
    <div class="row justify-content-center">
        <div class="col-md-6">
            <div class='alert alert-success mt-3' role='alert'>
                Token yang dihasilkan: 
                <h1 class="text-center token" id="tokenDisplay">Loading...</h1><br>
                Token ini akan berubah setiap 15 menit.
            </div>

            <div class='alert alert-info mt-2' role='alert'>
                Token akan diganti dalam: <strong id="timeLeft">00 menit 00 detik</strong>
            </div>
        </div>
    </div>
</div>

<!-- Bootstrap JS -->
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"></script>
<!-- jQuery -->
<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script>
    var timeLeft;
    var interval;

    // Fungsi untuk memperbarui token tanpa reload
    function updateToken() {
        $.ajax({
            url: 'generate_token.php',
            type: 'GET',
            dataType: 'json',
            success: function(response) {
                if (response.status === 'success' || response.status === 'valid') {
                    $('#tokenDisplay').text(response.token);

                    // Menghitung sisa waktu sampai token expired
                    var currentTime = Math.floor(Date.now() / 1000); // Waktu sekarang dalam detik
                    var expTime = Math.floor(new Date(response.tgl_exp).getTime() / 1000); // Konversi tgl_exp dari server ke detik

                    timeLeft = expTime - currentTime; // Sisa waktu dalam detik
                    if (interval) clearInterval(interval); // Hapus interval lama jika ada
                    startCountdown(); // Mulai countdown baru
                } else {
                    console.log(response.message);
                }
            },
            error: function(xhr, status, error) {
                console.log('Error: ' + error);
            }
        });
    }

    // Mulai countdown
    function startCountdown() {
        interval = setInterval(function() {
            if (timeLeft <= 0) {
                clearInterval(interval);
                // Meminta token baru tanpa reload
                updateToken();
            } else {
                timeLeft--;
                var minutes = Math.floor(timeLeft / 60);
                var seconds = timeLeft % 60;
                $('#timeLeft').text(minutes + " menit " + (seconds < 10 ? '0' : '') + seconds + " detik");
            }
        }, 1000);
    }

    // Pertama kali memuat halaman, update token dan mulai countdown
    $(document).ready(function() {
        updateToken();  // Update token ketika halaman pertama kali dibuka
    });
</script>
</body>
</html>
